<?php

/*
 *  Copyright (c) 2012  Rasmus Fuhse <fuhse@data-quest.de>
 * 
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 */

class st_score extends SimpleORMap {
    protected $db_table = 'st_score';
    static protected $secret_key = 'z3ba20m1u6t';
    static protected $central_server = 'http://develop.studip.de/studip/';
    
    public function store() {
        parent::store();
        if (self::$central_server !== $GLOBALS['ABSOLUTE_URI_STUDIP']) {
            //Daten senden:
            $url = self::$central_server."plugins.php/SurvivalTrainingPlugin/receive_score";
            $url .= "?user_id=".urlencode($this->getValue('user_id'));
            $url .= "&user_name=".urlencode($this->getValue('user_name'));
            $url .= "&server_adress=".urlencode($this->getValue('server_adress'));
            $url .= "&server_name=".urlencode($this->getValue('server_name'));
            $url .= "&seminar_id=".urlencode($this->getValue('seminar_id'));
            $url .= "&seminar_name=".urlencode($this->getValue('seminar_name'));
            $url .= "&score=".urlencode($this->getValue('score'));
            $url .= "&secret=".urlencode(self::$secret_key);
            $response = json_decode(file_get_contents($url));
            var_dump($response);
        }
    }
    
    static public function insertScore($points) {
        $class = __class__;
        $score = new $class();
        $score['user_id'] = $GLOBALS['user']->id;
        $score['user_name'] = get_fullname();
        $score['seminar_id'] = $_SESSION['SessionSeminar'];
        $score['seminar_name'] = $GLOBALS['SessSemName'][0];
        $score['server_adress'] = $GLOBALS['ABSOLUTE_URI_STUDIP'];
        $score['server_name'] = $GLOBALS['UNI_NAME_CLEAN'];
        $score['score'] = $points;
        $score->store();
    }
    
    static public function getSecret() {
        return self::$secret_key;
    }
    
    static public function getServer() {
        return self::$central_server;
    }
    
    
}
