<?php

/*
 *  Copyright (c) 2012  Rasmus Fuhse <fuhse@data-quest.de>
 * 
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 */
?>
<style>
    table.active_table {
        border-collapse: collapse;
        margin: 10px;
    }
    table.active_table > thead > tr > th {
        padding: 5px;
        border: 1px solid lightgrey;
        border-bottom: 1px solid grey;
        background-image: none;
    }
    table.active_table > tbody > tr > td {
        padding: 5px;
        border: 1px solid lightgrey;
    }
    table.active_table > tbody > tr:hover > td {
        background-color: #eeeeee;
    }
</style>
<? if (count($score_list)) : ?>
<h2><?= _("Helden der Veranstaltung") ?></h2>
<table class="active_table">
    <thead>
        <th><?= _("Name") ?></th>
        <th><?= _("Datum") ?></th>
        <th><?= _("Punkte") ?></th>
    </thead>
    <tbody>
    <? foreach ($score_list as $list_entry) : ?>
        <tr>
            <td><?= htmlReady($list_entry['user_name']) ?></td>
            <td><?= date("j.n.Y", $list_entry['mkdate']) ?></td>
            <td><?= htmlReady($list_entry['score']) ?></td>
        </tr>
    <? endforeach ?>
    </tbody>
</table>
<? endif ?>

<? if (count($global_score_list)) : ?>
<h2><?= _("Superhelden") ?></h2>
<table class="active_table">
    <thead>
        <th><?= _("Name") ?></th>
        <th><?= _("Datum") ?></th>
        <th><?= _("Veranstaltung") ?></th>
        <th><?= _("Server") ?></th>
        <th><?= _("Punkte") ?></th>
    </thead>
    <tbody>
    <? foreach ($global_score_list as $list_entry) : ?>
        <tr>
            <td><?= htmlReady(studip_utf8decode($list_entry->user_name)) ?></td>
            <td><?= date("j.n.Y", $list_entry->mkdate) ?></td>
            <td><?= htmlReady(studip_utf8decode($list_entry->seminar_name)) ?></td>
            <td><?= htmlReady(studip_utf8decode($list_entry->server_name)) ?></td>
            <td><?= htmlReady($list_entry->score) ?></td>
        </tr>
    <? endforeach ?>
    </tbody>
</table>
<? endif ?>
